require "class"
require "projectile"
require "obstacle"

require "cabinet"

class "Level" {
    background = love.graphics.newImage("graphics/background.png"),
}

function Level:__init__()
    local pedestals = {
        { 3,  2},
        { 3,  5},
        { 8, 11},
        {12, 21},
        {14,  4},
        {24, 21},
    }

    for _, coords in pairs(pedestals) do
        local x, y = unpack(coords)

        x = x * 32 + 28
        y = y * 32 + 28

        world:add(Obstacle(x, y))
        world:add(Projectile(x, y, x, y, true))
    end

    local vcabinets = {
        { 5, 13},
        { 5, 18},
        { 8,  4},
        {13, 10},
        {13, 15},
        {21, 10},
        {27, 10},
    }

    for _, coords in pairs(vcabinets) do
        local x, y = unpack(coords)

        x = x * 32 + 21
        y = y * 32 + 28

        world:add(Cabinet1(x, y))
        --world:add(Projectile(x, y, x, y, true))
    end

    local hcabinets = {
        {17,  9},
        {20, 17},
        {21,  3},
        {26,  3},
        {28, 17},
    }

    for _, coords in pairs(hcabinets) do
        local x, y = unpack(coords)

        x = x * 32 + 21
        y = y * 32 + 26

        world:add(Cabinet2(x, y))
        --world:add(Projectile(x, y, x, y, true))
    end

    --[[
    for y=32+16,1024-12,32 do
        for x=32+16,768-12,32 do
            if math.random() > 0.95 then
                world:add(Obstacle(x, y))
                world:add(Projectile(x, y, x, y, true))
            end
        end
    end

    for i=1,2 do
        local x, y = math.random(16, 1024 - 16), math.random(16, 768 - 16)
        
        world:add(Cabinet1(x, y))
    end

    for i=1,2 do
        local x, y = math.random(16, 1024 - 16), math.random(16, 768 - 16)
        world:add(Cabinet2(x, y))
    end
    ]]
end

function Level:update(dt)
end

function Level:draw()
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.setBlendMode("alpha")
    love.graphics.draw(self.background)
end
