shapes = require "collider.shapes"

require "class"
require "object"
require "sound"

class "Projectile" (Object) {
    image = love.graphics.newImage("graphics/gem.png"),
    speed = 1,
    layer = 2,
}

function Projectile:__init__(sx, sy, tx, ty, static)
    self.x, self.y = 0, 0
    self.sx, self.sy = sx, sy
    self.tx, self.ty = tx, ty
    self.u = 0

    self.cooldown = 1

    self.a = math.random() * math.pi * 2
    self.va = (0.5 + math.random() * 0.5) * math.pi * 2

    self.shape = shapes.newCircleShape(self.x, self.y, 32)
    self.shape.info = {type = "projectile", object = self}

    self.motion = true

    if static then
        self.u = 1
        self.tx = self.sx
        self.ty = self.sy - 1
        self.va = 0
        self.a = 0
        self.motion = false
    end
end

function Projectile:update(dt)
    if self.motion then
        self.u = math.min(self.u + self.speed * dt, 1)

        if self.u >= 1 then self:land() end
    end

    self.x = self.sx + (self.tx - self.sx) * self.u
    self.y = self.sy + (self.ty - self.sy) * self.u
    self.a = self.a + self.va * dt

    self.shape:moveTo(self.x, self.y)
end

function Projectile:draw()
    local i = 1 - math.abs((self.u - 0.5) * 2)

    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.setBlendMode("alpha")
    love.graphics.draw(self.image, self.x, self.y, self.a, 1+0.75*i, 1+0.75*i, 25, 25)
end

function Projectile:land()
    sounds.land:stop()
    sounds.land:play()

    self.va = 0
    self.motion = false
    world:add(Sound(self.x, self.y, 0.25))
end
