require "class"
require "object"

class "Sound" (Object) {
    image = love.graphics.newImage("graphics/sound.png"),
}

function Sound:__init__(x, y, scale)
    self.x, self.y = x, y

    self.u = 0
    self.scale = scale
end

function Sound:update(dt)
    self.u = math.min(self.u + 3*dt, 1)

    if self.u >= 1 then
        world:remove(self)
        guard:alert(self.x, self.y, self.scale)
    end
end

function Sound:draw()
    love.graphics.setColor(255, 255, 255, 255 * (1 - self.u))
    love.graphics.setBlendMode("additive")
    love.graphics.draw(self.image, self.x, self.y, 0, 
                       self.u * self.scale, self.u * self.scale,
                       768/2, 768/2)
end
